﻿-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
local helper = require('scenario/scenariohelper')
--local vdata = {}  -- Current ai vehicle data
--local tdata = {}  --Target data

local user = "Hawk"
local target = nil
local targetSet = false
local hitTarget =  false
local lasthit = false
local backup = false
local brake = 0
local throttle = 0
local collision = false
local vdataPos = nil
local vdataVel = nil
local tdataPos = nil
local tdataVel = nil
local callReset = false

require('mathlib')
local function debug(aiDirVec, targetAiMidPos, targetLength, dt, vName)
	--if test2 ~= nil then
	--	debugDrawer:drawSphere(test2:toPoint3F(), 4, ColorF(1,0,0,0.3))
	--end
	--local debugDrawer = obj.debugDrawProxy
	
	if tdataPos ~= nil and targetAiMidPos ~= nil then
		--debugDrawer:drawSphere(test:toPoint3F(), 1.5, ColorF(1,0,0,0.3))
	local speed = vdataVel:length()
	--if speed < 4 then
	--	speed = 5
	--else 
	--	speed = speed 
	--end

	local tspeed = tdataVel:length()
	
	local futurePos = vdataPos + (vdataVel):normalized() * speed
	local futureTarget = tdataPos +  ((tdataVel:normalized()) * tspeed)
	local futurePos2 = vdataPos + vdataVel
	debugDrawer:drawSphere(futurePos:toPoint3F(), 0.5, ColorF(1,0,0,0.3))
	debugDrawer:drawSphere(futureTarget:toPoint3F(), 0.5, ColorF(0,1,0,1))
	--debugDrawer:drawSphere(futurePos2:toPoint3F(), 0.5, ColorF(1,1,0,1))
    --debugDrawer:drawSphere((aiDirVec*targetLength + futureTarget):toPoint3F(), 0.5, ColorF(0,1,0,1))
   -- debugDrawer:drawSphere(targetAiMidPos:toPoint3F(), 0.3, ColorF(1,0,0,0.3))
	end
end
-------------------------------------------------------------------------------------
--RETURNS A TARGET FOR THE AI  *vNotToTarget - set AI to not target itself
-------------------------------------------------------------------------------------
local function findRandomTarget(vNotToTarget)
	local sVehicles = scenario_derby_vehicles.sVehicles
	local vehIn = scenario_derby_main.vehIn
	local vTimeout = scenario_derby_main.vTimeout
	local targetList = {}
	local dirVec = map.objects[map.objectNames[vNotToTarget]].dirVec
	local bestTargetVec = 0
	local lastbest = {}
	local cCount = scenario_derby_vehicles.vehicleData[vNotToTarget].cCount
	if cCount < 1 then
	local point = scenario_derby_util.findRandomPoint()
		scenario_derby_vehicles.vehicleData[vNotToTarget].targetObj = point
		targetList = "point"
		tdataPos = point
		cCount = cCount + 1
		scenario_derby_vehicles.vehicleData[vNotToTarget].cCount = cCount
		collision = true
		return	targetList
	else 
		for k, vName in pairs(sVehicles) do
			if vName ~= vNotToTarget and not vTimeout[vName] then
			--if vehIn > 2 then
				--if scenario_derby_main.stopTicks[vName] < 100 then 
					local vObj = scenetree.findObject(vName)
					local position =  vObj:getPosition()
					local targetVec = (vec3(position) - vec3(vdataPos)):normalized()
					local i = math.abs(dirVec:dot(targetVec))
					lastbest[vName] = i	
					if i >= bestTargetVec then	
						bestTargetVec = i
					end
				--end
			--else
			--	table.insert(targetList, vName)
			--end
			end
		end
		for vName, i in pairs(lastbest) do
			if i == bestTargetVec then  
			table.insert(targetList, vName)
			end
		end
		local j = nil
				j = tableChooseRandomKey(targetList)
		return targetList[j]
	end
	--local cCount = scenario_derby_vehicles.vehicleData[vNotToTarget].cCount 
	--if cCount < 1 then
		--print(cCount)
		--local point = scenario_derby_util.findRandomPoint()
		--local targetVec = (vec3(point) - vdataPos):normalized()
		--local dirTarget = dirVec:dot(targetVec)
		--if math.abs(dirTarget) > bestTargetVec then
			--targetList = "point" 
			--tdataPos = point
			--print("thepoint")
			--scenario_derby_vehicles.vehicleData[vNotToTarget].targetObj = point
		--end
		--cCount = cCount + 1 
		--scenario_derby_vehicles.vehicleData[vNotToTarget].cCount =  cCount
	--end
--	return targetList
	--		else 
		--		table.insert(targetList, vName)
	--			count = count + 1
	--		end
	--	end
	--end	
	--local j = nil
	--if count > 0 then
	--	j = tableChooseRandomKey(targetList)
	--	return targetList[j]
--	else
		--local cCount = scenario_derby_vehicles.vehicleData[vNotToTarget].cCount
		--if cCount > 0 then
		--[[
				for k, vName in pairs(sVehicles) do
					if vName ~= vNotToTarget and not vTimeout[vName] then
						if vehIn > 2 then
							if scenario_derby_main.stopTicks[vName] < 100 then 
								table.insert(targetList, vName)
							end
						else 
							table.insert(targetList, vName)
						end
					end
				end

				

				local j = nil
				j = tableChooseRandomKey(targetList)
				return targetList[j]--]]
		--else 
			
			--if dirTarget > 0.3 or dirTarget < -0.3 then
				--targetList = {["point"] = point}
			--	return targetList["point"]
			--	scenario_derby_vehicles.vehicleData[vNotToTarget].cCount = cCount + 1 
			--elseif not vTimeout[user] then
			--	targetList = user
			--	return targetList
			--else
			--	targetList = {["point"] = point}
			--	return targetList["point"]
			--	scenario_derby_vehicles.vehicleData[vNotToTarget].cCount = cCount + 1 
			--end
			
	--	end
		
	--end
end
-------------------------------------------------------------------------------------
--OBJECT TO AVOID BEHIND OR AHEAD 
-------------------------------------------------------------------------------------
--local function aiflee(t)
--	local tpos = nil
--		tpos = t 
--		local dirDiff, dirTarget, dirVec = scenario_derby_util.vec2Diff(tpos, vdata)
--		return dirDiff, dirTarget
--end
-------------------------------------------------------------------------------------
--GETS DIRECTION AND DISTANCE OF THE TARGET
-------------------------------------------------------------------------------------
local function aiPursuit(vName, dt)	
		--tdataPos = map.objects[map.objectNames[target]].pos
		local vdataDir = map.objects[map.objectNames[vName]].dirVec
		if target == "point" then
			tdataVel = vec3(0,0,0)
		else
			tdataVel = map.objects[map.objectNames[target]].vel
		end
		local tvel = tdataVel
		local dirDiff, dirTarget, dirVec = scenario_derby_util.vec2Diff(tdataPos, tdataVel, vdataPos, vdataDir, vdataVel, dt)
		local curVel = tvel:length()
		local targetLength = math.max(curVel * 0.6, 8)
		local halfRemainder = targetLength * 0.5
		local vec = vdataPos - tdataPos
		local vecLen = vec:length()
		local targetAiMidPos =  tdataPos + vec * math.min(halfRemainder,vecLen) / vecLen
		-- local targetVec = (tpos - vpos):normalized()
		 local aiDirVec = vdataDir
		--local dirTarget = aiDirVec:dot(targetVec)
		--local vecUp = vdata.dirUp
		--local dirDiff = -math.asin(dirVec:cross(vec3(vecUp)):dot(targetVec))
		

		
		 --local dirDiff = math.asin(aiDirVec.x * targetVec.y - aiDirVec.y * targetVec.x)
		--debug(aiDirVec,targetAiMidPos, targetLength, dt, vName)
		--local futurePos = nil
		--if tdata.vel:length() > .01 then 
		--local vR = tdata.vel - vdata.vel
		--print(vR)
		--local sR = tdata.pos - vdata.pos
		--print(sR)
		--local sRMag = sR:length()
		--local vRMag = vR:length()
		--tC = sRMag / vRMag
		--print(tC)
		--futurePos = tdata.pos + (tdata.vel * tC)
		--futurePos.z = tdata.pos.z
	--	else 
		--local futurePos = (vdata.pos - tdata.pos):normalized()
		--futurePos.z = vdata.pos.z
		--local targetVec = (vdata.pos - tdata.pos):normalized()
		--end

		--debug(futurePos)
		
		--local dirVec = vdata.dirVec:normalized()
		--local dirDiff, dirTarget, dirVec = scenario_derby_util.vec2Diff(tpos, vdata)
		--local aiVel2Target = vec3(vdata.vel):dot((tpos - vdata.pos):normalized())
		--local aiTimeToTarget =  distance / speed  --(tdata.pos - vdata.pos):length() / (aiVel2Target + 1e-30)
		--local tspeed = tdata.vel:length()
		--local futurePos = tdataPos - vdataPos + vdataVel --aiTimeToTarget)
		--debug(futurePos)
		--local targetVec = futurePos:normalized()
		--local targetVec = (futurePos - vdataPos):normalized()
		--local check = vec3(targetVec)
		--debug(check)
		--targetVec = targetVec:normalized()
		--local targetVec = targetVec:normalized()
		--debugDrawer:drawSphere(targetVec:toPoint3F(), 4, ColorF(1,0,0,0.3))
		--debug(targetVec)
		--local dirTarget = dirVec:dot(targetVec)
	
		--debugDrawer:drawLine(vdata.pos:toPoint3F(), futurePos:toPoint3F(), ColorF(1,0,0,0.5))
		--local dirDiff = math.asin(dirVec.x * targetVec.y - dirVec.y * targetVec.x)
		--if dirDiff2 > 0 or dirDiff2 < 0 then
		--	dirDiff = dirDiff2
		--end
		return dirDiff, dirTarget
end
-------------------------------------------------------------------------------------
--RESET TARGET 
-------------------------------------------------------------------------------------
local function reset()
	targetSet = false
	target = nil
	--data.targetObj = {}
end
-------------------------------------------------------------------------------------
--CHECK IF WE ARE GONG TO HIT WALLS
-------------------------------------------------------------------------------------
local function wall(speed, dt)
	local wp1 = scenario_derby_main.wp1
	local wp2 = scenario_derby_main.wp2
	local ahead = vdataPos + (vdataVel):normalized() * speed
	local result = nil
	local dx = nil
	local dy = nil
	dx, dy, result = scenario_derby_util.findIntersect(vdataPos.x, vdataPos.y, ahead.x,ahead.y, wp1.x, wp1.y, wp1.x, wp2.y)
	if result == nil then
		dx, dy, result = scenario_derby_util.findIntersect(vdataPos.x, vdataPos.y, ahead.x,ahead.y, wp2.x, wp2.y, wp2.x, wp1.y)
	end
	if result == nil then 
		dx, dy, result = scenario_derby_util.findIntersect(vdataPos.x, vdataPos.y, ahead.x,ahead.y, wp1.x, wp1.y, wp2.x, wp1.y)
	end
	if result == nil then
		dx, dy, result = scenario_derby_util.findIntersect(vdataPos.x, vdataPos.y, ahead.x,ahead.y, wp2.x, wp2.y, wp1.x, wp2.y)
	end
	local dz = vdataPos.z
	local lineIntersect = vec3(dx, dy, dz)
	--debug(lineIntersect)
	return lineIntersect, result
end
local function closest_point_on_seg(speed,circle)
			local closest = 0
		--	if speed < 4 then
			--	speed = 1.8
			--else 
			--	speed = speed * .5 
			--end
			local line = vdataPos + vdataVel 
			local linetocircle = circle - vdataPos
			local line_unit = line / line:length()
			local proj = linetocircle:dot(line_unit)
			if proj <= 0 then
				closest = vdataPos
			elseif proj >= line:length() then
				closest =  line
			else
				local proj_v = line_unit * proj
				closest = proj_v + vdataPos
			end
			return closest
end
-------------------------------------------------------------------------------------
--CHECKS FOR COLLISIONS WITH OBJECTS 
-------------------------------------------------------------------------------------
local function collisionCheck(vName, dt)
	local Arena = scenario_derby_main.Arena
	local dirDiff
	local dirTarget 
	--local targetVec
	--local vdata = map.objects[map.objectNames[vName]]
	if target == "point" then
			--print(vName)
			--print(target["point"])
			--tdataPos = target["point"]
			tdataVel = vec3(0,0,0)
	else 
		tdataPos = map.objects[map.objectNames[target]].pos
		tdataVel = map.objects[map.objectNames[target]].vel
	end
	local speed = vdataVel:length()
	
	local circleOffset
	if Arena == 1 then
			local cr = 9
			local cx = 157.99
			local cy = -198.1715
			local z = 58.55
			local circle = vec3(cx,cy,z)
			local offset = nil 
			--debugDrawer:drawSphere(circle:toPoint3F(), cr, ColorF(1,0,0,0.3))
			
			local closest = closest_point_on_seg(speed,circle)
			local dist_v = circle - closest
			if dist_v:length() > cr then
			elseif dist_v:length() <= 0 then
			else
				offset = dist_v /dist_v:length() * (cr - dist_v:length())

			--local ahead3 = vdata.pos + (vdata.vel):normalized() * 3 * 0.5
			--local distance1 = vec3(ahead2):distance(vec3(circle))
			--local distance2 = vec3(ahead3):distance(vec3(circle))
			--cr = cr + 3
			--if distance1 <= cr or distance2 <= cr then
					--dirDiff	= distanceAction(offset, dirDiff)
			--	data.avoid = true
			--return dirDiff, dirTarget

			circleOffset = closest --+ offset 
		--	debug(circleOffset)

			local point = circleOffset
			scenario_derby_vehicles.vehicleData[vName].targetObj = point
			target = "point"
			tdataPos = point
			--dirDiff, dirTarget = scenario_derby_util.vec2Diff(circleOffset)
			end
	end
	local lineIntersect, result = wall(speed, dt)
	--print(result)
	--print(lineIntersect)
	if result ~= nil then
		collision = true
		local point = scenario_derby_vehicles.vehicleData[vName].startPos
		scenario_derby_vehicles.vehicleData[vName].targetObj = point
		target = "point"
		tdataPos = point

		
		
			--debugDrawer:drawSphere(lineIntersect:toPoint3F(), 0.5, ColorF(1,0,0,0.3))
		--print("true line Intersect")
		--debugDrawer:drawLine(vdata.pos:toPoint3F(), data.lineDist:toPoint3F(), ColorF(1,0,0,0.5))
		--if target ~= "point" then
		
		--[[local startPos = scenario_derby_vehicles.vehicleData[vName].lineIntersect
		target = "point"
		tdataPos = lineIntersect
		targetSet = true
		--print("startPos")
		scenario_derby_vehicles.vehicleData[vName].targetObj = lineInterect--]]
		
		--end
			--dirDiff, dirTarget = aiflee(target)
			--data.sDist = vec3(vdata.pos):distance(vec3(startPos))
			--dirDiff = 0 
		--if dirTarget < 0 then
		--	if speed > 6 then
		--		brake = 0.6
		--			thottle = 0
		--		else 
			--		brake = 0.5
			--		throttle = 0
		--		end
				--	backup = true
			--else 
			--	if speed > 6 then
			--		throttle = 0.7
			--		brake = 0 
			--	else 
				--	throtle = 0.5
				--	brake = 0
			--	end
			--	backup = false

			--end
			
			--lasthit = false
	end
   
	dirDiff, dirTarget = aiPursuit(vName, dt)
	return dirDiff, dirTarget
	
end
-------------------------------------------------------------------------------------
--CHANGES THE DIRECTION FOR FORWARE TO BACKWARDS
-------------------------------------------------------------------------------------
local function changeDir()
	if backup == false then
		backup = true
	else 
		backup = false
	end
end
-------------------------------------------------------------------------------------
--SETS THE COUNT FOR HOW LONG WE GO FORWARD OR BACKWARDS
-------------------------------------------------------------------------------------
local function counts(vName, dirTarget)
	local lCount = scenario_derby_vehicles.vehicleData[vName].lCount
	local dtCount = scenario_derby_vehicles.vehicleData[vName].dtCount
	--if target == "point" then
	--	lCount = 201
	--end
--	print(lCount .."lCount " ..dtCount .. "dtCount")
	if collision == false then					
		if lasthit == true then
			if lCount == 1 then 
				changeDir()
			end
			if lCount > 200 then
				if hitTarget == true then
					callReset = true
					hitTarget = false
				end
				lasthit = false
				lCount = 0
			else
				callReset = false
				lCount = lCount + 1
			end
		else
			if dtCount < 300 then
				callReset = false
				dtCount = dtCount + 1 
				if dirTarget < -0.3 then
					backup = true
				else
					backup = false	
				end
			else
				dtCount = 0
				lCount = 0
				callReset = true
			end
		end
	else
		--print(tDist .. " " .. vName)
		--dump(target)
		--local pedal = .4
		--local speed = vdataVel:length()
		--if speed > 6 then
		--	pedal = pedal + (speed * 0.03)
	--		if pedal > 1 then 
	--			pedal = 1
	--		end
	--	end
		tdataPos = scenario_derby_vehicles.vehicleData[vName].targetObj
		local tDist = vec3(vdataPos):distance(vec3(tdataPos))
		--print(tDist)
		if tDist < 8   then
			callReset = true
			collision = false 
		else
			callReset = false
			local stopTicks = scenario_derby_main.stopTicks[vName]
			if stopTicks > 199 and stopTicks < 400 then
				if stopTicks == 200 then
					scenario_derby_vehicles.vehicleData[vName].cCount = 0
					changeDir()
				end
			else
				if dirTarget < 0 then
					backup = true
				else 
					backup = false
				end
			end
		end
	end
	scenario_derby_vehicles.vehicleData[vName].lCount = lCount
	scenario_derby_vehicles.vehicleData[vName].dtCount = dtCount
end
-------------------------------------------------------------------------------------
-- AI CODE
-------------------------------------------------------------------------------------
local function update(vName, dt)
	
	 targetSet = scenario_derby_vehicles.vehicleData[vName].targetSet
	 hitTarget =  scenario_derby_vehicles.vehicleData[vName].hitTarget
	 lasthit = scenario_derby_vehicles.vehicleData[vName].lasthit
	 backup = scenario_derby_vehicles.vehicleData[vName].backup
	 brake = scenario_derby_vehicles.vehicleData[vName].brake
	 throttle = scenario_derby_vehicles.vehicleData[vName].throttle
	 collision = scenario_derby_vehicles.vehicleData[vName].collision
	 local vdata = map.objects[map.objectNames[vName]]
	 if not vdata then return end
	 vdataPos = vdata.pos
	 vdataVel = vdata.vel
	--if we don't have a target find one
	if targetSet ~= true then
		target = findRandomTarget(vName)  --find a random target
		if not target then target = user end	
		--targetObj = scenetree.findObject(target)
		targetSet = true
	else
		target = scenario_derby_vehicles.vehicleData[vName].target
		--print(target)
		 --Update Data		
		--map.objects returns objId, isactive, pos, vel, dirVec, dirVecUp, damage, objectCollisions
			--tdata = map.objects[map.objectNames[target]]
			
		--if target["point"] then
			--print(vName)
			--print(target["point"])
			--tdata.pos = target["point"]
			--tdata.vel = vec3(0,0,0)
		--else 
	
		local aiCollisions = map.objects[map.objectNames[vName]].objectCollisions
			--local targetObj = scenetree.findObject(target)
			--local targetID = targetObj.obj:getID()  --get target id
		if target ~= "point" then
			local vObj = scenetree.findObject(target)
			local targetID = vObj.obj:getID()
		--else
			--tdataPos = scenario_derby_vehicles.vehicleData[vName].targetObj
			--local tDist = vec3(vdataPos):distance(vec3(tdataPos))
			--if tDist < 15 then
				--hitTarget = true
				--lasthit = true
			--end
		end
		--dump(aiCollisions)
		--print(targetID)
			if aiCollisions ~= nil then
				--dump (aiCollisions)
				for k,v in pairs (aiCollisions) do
					--print(k.." "..targetID)
					if k == targetID then		
						hitTarget = true
					else
						hitTarget = false
					end			
					local sVehiclesID = scenario_derby_vehicles.sVehiclesID
					if not sVehiclesID[k] then
						collision = true
					else
						lasthit = true
					end 
					
				end	
			end
		local dirDiff, dirTarget = collisionCheck(vName, dt)
		local bt = nil 
		--local wheelSlip = scenario_derby_wheels.slipHigh()
		counts(vName, dirTarget)
			if backup == true then
				bt = scenario_derby_vehicles.adjustBrakeThrottle(brake,vdataVel, dirTarget)
				throttle = 0
				brake = bt
			else
				bt = scenario_derby_vehicles.adjustBrakeThrottle(throttle,vdataVel, dirTarget)
				brake = 0 
				throttle = bt
			end
		
		--print(collision)
		--print("collision")
		
		--print("throttle".. throttle.. "brake ".. brake.. " " .. vName .. " " ..target.."")
		
		--print(backup)
		--print("backup")
		--print(hitTarget)
		--print("hitTarget") 
		--print(lasthit) 
		--print("lasthit")
		--print(dirTarget.. "dirTarget ".. dirDiff .. "dirDiff ")
		--guihooks.trigger('DerbyPlaceChange', { one = dirTarget, two = throttle, three = brake} )	
		--local vObj = scenetree.findObject(vName)
		--if collision == true then 
		--	vObj:queueLuaCommand('input.event("throttle", '..throttle..', 2)')
		--	vObj:queueLuaCommand('input.event("brake", '..brake..', 2)')
		--end
		
		--if vObj then
		--	vObj:queueLuaCommand('input.event("steering", '..-dirDiff..', 1)')
	--	end
		if callReset == true then
			reset()
			brake = 0
			throttle = 0
		end
		scenario_derby_vehicles.driveCar(vName,-dirDiff,throttle,brake,0)
		
		
	end
	scenario_derby_vehicles.vehicleData[vName].target = target
	scenario_derby_vehicles.vehicleData[vName].targetSet = targetSet 
	scenario_derby_vehicles.vehicleData[vName].hitTarget = hitTarget
	scenario_derby_vehicles.vehicleData[vName].lasthit = lasthit
	scenario_derby_vehicles.vehicleData[vName].backup = backup
	scenario_derby_vehicles.vehicleData[vName].brake = brake
	scenario_derby_vehicles.vehicleData[vName].throttle = throttle
	scenario_derby_vehicles.vehicleData[vName].collision = collision
end

M.update = update


return M