-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
local startvehicleConfig = 0
local startvehicleClass = 0  
local user = "Hawk"
local removePartsFile = {} --Table of parts to remove
local helper = require('scenario/scenariohelper')
M.vehicleData = {}
M.pathData = {}
M.sVehicles = {}
M.sVehiclesID = {}

-------------------------------------------------------------------------------------
--TORQUE SCRIPT TO SET THE PARTS Config
-------------------------------------------------------------------------------------
local function TScript(vName,JBeam,pcs)
	TorqueScript.eval([[
			]]..vName..[[.JBeam = "]] .. JBeam .. [[";
			]]..vName..[[.partConfig = "]] .. pcs .. [[";
			]]..vName..[[.requestReload();
		]])
end
-------------------------------------------------------------------------------------
--SETS THE PARTS FOR EACH vehicle
-------------------------------------------------------------------------------------
local function partsConfig(firstLoad)
	if firstLoad == true then
	 startvehicleConfig = vehicleConfig
	 startvehicleClass = vehicleClass
	end
	local vehicleConfig = scenario_derby_main.vehicleConfig
	local vehicleClass = scenario_derby_main.vehicleClass
	local includeMods = scenario_derby_main.includeMods
	local path = string.format('levels/derby/configs/removeParts.pc')
	removePartsFile = scenario_derby_classes.readPartsFile(path)
	local JBeam, pcs = scenario_derby_classes.loadClass(removePartsFile)
	--dump(pcs)	
	if startvehicleConfig == vehicleConfig and startvehicleClass == vehicleClass then	
		if firstLoad == true or includeMods > 1 then		
			TScript(user,JBeam,pcs)
		end
	else
		TScript(user,JBeam,pcs)
	end	
end
-------------------------------------------------------------------------------------
--MOVE THE VEHICLES TO THEIR STARTING POSITION
-------------------------------------------------------------------------------------
local function moveVehiclesPosition(vName, vehicleOffset, k)
		--Get the Waypoint x, y, and z positions 
		local wp1 = scenario_derby_main.wp1
		local wp2 = scenario_derby_main.wp2
		local Arena = scenario_derby_main.Arena
		local pos = {}
		local offset = 30
		if Arena == 1 then
			offset = 50
		end
		if k > 8 then
			if Arena == 4 or Arena == 5 then  --Oval Track or Figure 8
				pos.x = wp1.x + wp2.x - 8 
				pos.y = wp1.y + wp2.y  
			else
				pos.x = wp1.x + wp2.x 
				pos.y = wp1.y + wp2.y - offset
			end
		else
			pos.x = wp1.x + wp2.x
			pos.y = wp1.y + wp2.y 
		end
		pos.z = wp1.z	
		--Offsets the vehicles so they don't get moved over one another
		if Arena == 4 or Arena == 5 then
			pos.y = (pos.y + vehicleOffset) / 2
			pos.x = pos.x /2
		else
			pos.x = (pos.x + vehicleOffset) / 2
			pos.y = pos.y / 2
		end
		if Arena == 1 then
			print("moved y position")
			pos.y = pos.y + 15
		end
		print("x "..pos.x.. " y "..pos.y.. " z " .. pos.z)
		--Command to move the vehicles
		TorqueScript.eval('if(isObject('..vName..')){'..vName..'.position =" '..pos.x..' '..pos.y..' '..pos.z..' ";}')	
end
-------------------------------------------------------------------------------------
--CREATES THE AI VEHICLES FOR THE SCENARIO  
-------------------------------------------------------------------------------------
local function createVehicles()
		local vehicleCountEntered = scenario_derby_main.vehicleCountEntered
		local driver = {"Basher","Tee","Little","John","Tim","Bo","Greg","Driver8","Driver9","Driver10","Driver11","Driver12","Driver13","Driver14","Driver15","Driver16"}
		partsConfig(false)
	--color = "0.718231 0.36428 0.92572 1.426";
		for i=1,vehicleCountEntered do
			--JBeam is the vehicle type, and pcs is the parts Configuration
			local JBeam, pcs = scenario_derby_classes.loadClass(removePartsFile)
			local position = '177.222 120.331 79.2748'
			local vehicleTS = [[
			new BeamNGVehicle(]]..driver[i]..[[) {
			JBeam = "]]..JBeam..[[";
			partConfig = "]]..pcs..[[";
			renderDistance = "500";
			renderFade = "0.1";
			isAIControlled = "0";
			dataBlock = "default_vehicle";
			position = "]]..position..[[";
			rotation = "1 0 0 0";
			scale = "1 1 1";
			canSave = "1";
			canSaveDynamicFields = "1";
			};
			]]
			TorqueScript.eval(vehicleTS)
			be:reloadCollision()
		end
		--local ScenarioObjectsGroup = createObject('SimGroup') 
		  --local MissionGroup = scenetree.MissionGroup
		--ScenarioObjectsGroup:registerObject('DerbyObjectsGroup')
		--ScenarioObjectsGroup.canSave = false
		--MissionGroup:addObject(ScenarioObjectsGroup.obj)
		--MissionGroup:addObject(ScenarioObjectsGroup.obj)
		--local p = createObject('Prefab')
		--p.loadMode = 1
		--p:setField('position', '', '0 0 0')
		--p:setField('rotation', '', '0 0 1')
		--p:setField('scale', '', '1 1 1')
		--p.canSave = true
		--p.canSaveDynamicFields = true
		--p:registerObject('Test')
		--p:load();


		

		--local test = spawnPrefab("Test","", '0 0 0', '0 0 1', '1 1 1')
		
		--dump(Test)
		--ScenarioObjectsGroup:addObject(Test.obj)
		--local sVehicles = scenetree.findClassObjects('BeamNGVehicle')
		--for k, vName in pairs(sVehicles) do	
		--if k ~= 1 then
		--local vObj = scenetree.findObject(vName)
		--	ScenarioObjectsGroup:addObject(vObj.obj)
		--end
		--end

end
-------------------------------------------------------------------------------------
--FUNCTION TO FREEZE AND UNFREEZE VEHICLES BEFORE THE START
-------------------------------------------------------------------------------------
local function freezeAll(state, vName)
	local vObj = scenetree.findObject(vName)
	if vObj then
		vObj:queueLuaCommand('controller.setFreeze('..tostring(state) ..')')
	end
end
local function setupVehicles(vName)
	
	--local sVehicles = scenetree.findClassObjects('BeamNGVehicle')
	--for k, vName in pairs(sVehicles) do	
		--print("setupVehicles "..vName)
			-- Set blank data for this ai vehicle
		
	M.vehicleData[vName] = {
				targetSet = false, 
				targetOut = nil,
				target = nil,  --Target vehicle name
				targetObj = nil,
				backup = false,
				forward = true,
				lasthit = false,
				throttle = 0,
				brake = 0,
				startPos = vec3(0, 0, 0),
				hitTarget = false,
				sDist = 0,  --Start Distance
				tDist = 0,  --Target Distance
				collision = false,
				--randomPointTimer = math.random(1,400),
				--randomPoint = vec3(0, 0, 0),
				dtCount = 0,
				lCount = 0,
				cCount = 0,
				hitID = 0,
				wheelspeed = nil,
				}	
	M.pathData[vName] = {
				line = nil,
				pathNode = nil,
				npathNode = nil,
				nodePos = nil,
				distance = nil,
				}
	
	scenario_derby_main.stopTicks[vName] = 1

	helper.trackVehicle(vName, vName)  --Track the Vehicle
	if vName ~= user then
		helper.setAiMode(vName, 'manual')  --Needed to setup the AI to Auto Shifting
	end
	local vObj = scenetree.findObject(vName)
	if vObj then
		local start = vObj:getPosition()	
		M.vehicleData[vName].startPos = vec3(start)
			--vObj:queueLuaCommand('obj:requestReset(RESET_PHYSICS)')  
			--vObj:resetBrokenFlexMesh()  --Repair Vehicles
	end
end
-------------------------------------------------------------------------------------
--LOAD vehicles
-------------------------------------------------------------------------------------
local function loadVehicles()
	--scenario = sc
	--resetvehicle()
	local Arena = scenario_derby_main.Arena
	local vehicleOffset = 0
	local offset = 8
	if Arena == 4 or Arena == 5 then  --Oval Track or Figure 8 
		offset = 18     -- Arenas
	end
	local sVehicles = scenetree.findClassObjects('BeamNGVehicle')
	log('D', 'scenario', "found " .. #sVehicles .. " vehicles")
	--local userVehicle = math.random(1, #sVehicles)
	local vehIn = 0 
	for k, vName in pairs(sVehicles) do	
			M.sVehicles[k] = vName
			local vObj = scenetree.findObject(vName)
			local id = vObj.obj:getID()
			M.sVehiclesID[id] = vName 
			--This sets the vehicle offset amount for moving vehicles to the starting spot
			if k == 1 or k == 9 then
				--Move the player 
				vehicleOffset = 0
				moveVehiclesPosition(vName, vehicleOffset, k)
			else
				--print("Checking Even Number Vehicle Offset value" ..vehicleOffset )
				if k % 2 == 0 then
					vehicleOffset = vehicleOffset + offset
				else 
						vehicleOffset = -1 * vehicleOffset
				end
				moveVehiclesPosition(vName, vehicleOffset, k)
				vehicleOffset = math.abs(vehicleOffset)
			end
			vehIn = vehIn + 1 
			setupVehicles(vName)
			freezeAll(1, vName)
			
	end	
		return vehIn
end
-------------------------------------------------------------------------------------
--DELETE VEHICLES 
-------------------------------------------------------------------------------------
local function deleteVehicles(vName)
		--TorqueScript.eval('setCameraFree();')
		local vObj = scenetree.findObject(vName)
		if vObj then
			--dump(obj)
			vObj:delete()
			--Update static collision with new prefabs
			be:reloadCollision()
		end
end
-------------------------------------------------------------------------------------
--GETS THE AI MOVING 
-------------------------------------------------------------------------------------
local function driveCar(vName,steering,throttle,brake,parkingbrake)
	--print("drive Car"..vName)
	local vObj = scenetree.findObject(vName)
	if vObj then
		vObj:queueLuaCommand('input.event("steering", '..steering..', 1)')
		vObj:queueLuaCommand('input.event("throttle", '..throttle..', 2)')
		vObj:queueLuaCommand('input.event("brake", '..brake..', 2)')
		vObj:queueLuaCommand('input.event("parkingbrake", '..parkingbrake..', 2)')
	end
end
local function adjustBrakeThorttle( value, vel, dirTarget)
	--print(wheelSlip)
	--print(value)
	local speed  = vel:length()
	local maxSlip = 14
	local Arena = scenario_derby_main.Arena
	if Arena == 3 or Arena == 6 then
		maxSlip = 11
	end
	if speed > 4 then
		if  dirTarget < 0.2 and dirTarget > -0.2 then
			if dirTarget < 0.1 and dirTarget > -0.1  then
				value = value - 0.10
			else 
				value = value - 0.08
			end	
			value = value - 0.01	
			--print("lower")
		end
	else
	if dirTarget > .30 and dirTarget < -.30 then
		if dirTarget > .70 or dirTarget < -.70 then
			if dirTarget > .90 and dirTarget <  -.90 then
				value = value + .14	
			else 
				value = value + .1	
			end
		else 
			value = value + 0.03
		end
	else
		value = value + 0.02
	end
	end

	local maxspeed = 0
	if speed < 4 then
		maxspeed = .7
	else 
		maxspeed = .9
	end
	if value > maxspeed then
		value = maxspeed
	elseif value < 0.00 then
		value = 0.00
	end
	return value
end


M.partsConfig = partsConfig
M.createVehicles = createVehicles
M.loadVehicles = loadVehicles
M.freezeAll = freezeAll
M.deleteVehicles = deleteVehicles
M.driveCar = driveCar
M.setupVehicles = setupVehicles
M.adjustBrakeThrottle = adjustBrakeThorttle
return M